include ComTool.inc

.code

include Exception.asm
include VariantDlgProc.asm
include QuickSearchDlgProc.asm
include ODBCconnection.asm
include DBSearch.asm
include GetFromDB.asm
include IDispRelease.asm
include getEnumCode.asm
include getArgumentTypesName.asm
include ParameterCode.asm
include checkLCID.asm
include getClassMemberCode.asm
include getVarTypeName.asm
include getInvokeType.asm
include Members.asm
include ReturnType.asm
include EnumValue.asm
include Classes.asm
include ComponentInterfaces.asm
include OpenComponent.asm
include infoDlgProc.asm
include VBBrowserProc.asm
include AboutDlgProc.asm
include ListView.asm
include TextMatrix.asm
include Columns.asm
include ListLib.asm
include RadAsmDlgProc.asm
include MainDlgProc.asm

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	
	_try offset ED_001 ;address of frame-based exception director
	
; ======================================================================================================================
	mov eax,hInst
	mov hInstance,eax
; ======================================================================================================================

return:
	_finally
	mov eax,TRUE
	ret
	
DllEntry Endp

GetOptions proc
	
	mov eax,offset AddinOpt
	ret

GetOptions endp

InstallDll proc hWin:DWORD,fOpt:DWORD

	_try offset ED_002 ;address of frame-based exception director
	
	push ebx
	
; ======================================================================================================================
	mov	ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHStruct,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpPStruct,eax
	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpDStruct,eax
	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	mov fOption,eax
	test eax,eax
	je @exit

	;Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDComTool,eax
	;toolbar button will have the same id as our menuitem
	mov mytbbutton.idCommand,eax 

	mov ebx,[lpHStruct] 
	mov ebx,(ADDINHANDLES ptr [ebx]).hToolBar 
	invoke SendMessage,ebx,TB_GETIMAGELIST,0,0 
	push eax 
	invoke LoadBitmap,hInstance,IDB_ACTIVEX
	pop edx 
	push eax 
	invoke ImageList_AddMasked,edx,eax,808080h 
	mov   mytbbutton.iBitmap,eax 
	pop eax 
	invoke DeleteObject,eax 
	invoke SendMessage,ebx,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0 
	invoke SendMessage,ebx,TB_INSERTBUTTON,-1,offset mytbbutton 

	; Tell RadASM messages we want to hook
	mov eax, AddInHook(AIM_COMMAND,AIM_CLOSE,AIM_TBRTOOLTIP)
;	or	eax, AddInHook(AIM_MENUREBUILD,AIM_TBRTOOLTIP,AIM_PROJECTOPENED,AIM_PROJECTCLOSE)
@exit:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
; ======================================================================================================================

return:
	pop ebx
	_finally
	ret 
	
InstallDll Endp

DllProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL osi:OSVERSIONINFO
	
	_try offset ED_003 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	; This proc handles messages sent from RadASM to our dll
	mov	eax, uMsg
	.if eax == AIM_COMMAND
		; Return TRUE to prevent RadASM and other DLL's from
		mov ecx, wParam
		and ecx, 0FFFFh
		.if ecx==IDComTool
			.if hMainDlg==0
	            mov osi.dwOSVersionInfoSize,sizeof osi
	            mov osi.szCSDVersion,128
	            invoke GetVersionEx,addr osi
	            .if eax==TRUE 
	                .if osi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS	;=1 win95/98
	                	;osi.szCSDVersion = (A=Windows 98 SE,C=Windows 95 OSR2)
	                	mov colref,00C0C0C0h ;win98
	                	
	                .elseif osi.dwPlatformId==VER_PLATFORM_WIN32_NT ;=2 winNT
	                	mov colref,00C8D0D4h ;win2K
	                	
	                .endif
	            .endif
				invoke DialogBoxParam,hInstance,IDD_DIALOG1,0,addr MainDlgProc,NULL
			.else
				invoke SetWindowPos,hMainDlg,HWND_TOP,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE
			.endif
		.endif
		mov eax,FALSE 
		jmp return
		
	.elseif eax==AIM_CLOSE
		mov edx,lpHStruct
		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_COMMANDTOINDEX,IDComTool,0
		mov edx,lpHStruct
		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_DELETEBUTTON,eax,0
		
	.elseif eax==AIM_TBRTOOLTIP
		mov	eax,wParam
		.if eax==IDComTool
			mov eax,offset szComToolToolTip
			jmp return
		.endif
		
	.endif
	mov eax,FALSE
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
DllProc Endp

End DllEntry
